package xyz.zhouxy.plusone.system.domain.model.account;

import java.util.Objects;
import java.util.regex.Pattern;

import xyz.zhouxy.plusone.commons.annotation.StaticFactoryMethod;
import xyz.zhouxy.plusone.commons.annotation.ValueObject;
import xyz.zhouxy.plusone.commons.constant.PatternConsts;
import xyz.zhouxy.plusone.commons.domain.ValidatableStringRecord;

/**
 * 值对象：昵称
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@ValueObject
public class Nickname extends ValidatableStringRecord {

    public static final Pattern REGEX = PatternConsts.NICKNAME;

    private Nickname(String value) {
        super(value, REGEX);
    }

    @StaticFactoryMethod(Nickname.class)
    public static Nickname of(String nickname) {
        return new Nickname(nickname);
    }

    @StaticFactoryMethod(Nickname.class)
    public static Nickname ofNullable(String nickname) {
        return Objects.nonNull(nickname) ? new Nickname(nickname) : null;
    }
}
